freeslot("S_MAR_SLIDE", "SPR2_MSLI")

states[S_MAR_SLIDE] = {
	sprite = SPR_PLAY,
	frame = SPR2_MSLI,
	tics = 1,
	nextstate = S_MAR_SLIDE
}

addHook("PlayerThink", function(player)
	if player.mo.skin == "mmario" then
		if (player.cmd.buttons & BT_CUSTOM3) and player.mo.standingslope
		and not player.slide
		and not player.markick
		and not player.groundpound
			local mo = player.mo
			local slope = mo.standingslope
			local x = cos(slope.xydirection)
			local y = sin(slope.xydirection)
			local angle = slope.xydirection
			if P_GetZAt(slope, mo.x+32*x, mo.y+32*y) > P_GetZAt(slope, mo.x, mo.y)
				angle = slope.xydirection+ANGLE_180
			end
			if player.speed <= 3*FU
				P_InstaThrust(player.mo, angle, 6*FU)
			end
			player.mo.state = S_MAR_SLIDE
			player.pflags = $1|PF_SPINNING
			player.slide = true
			player.powers[pw_strong] = $1|STR_ATTACK|STR_ANIM
		end
		
		
		if player.slide
			player.mo.state = S_MAR_SLIDE
			if (player.speed <= FU and not player.mo.standingslope)
			or (player.pflags & PF_JUMPED)
			or player.spinjum
			or P_PlayerInPain(player)
				player.pflags = $ & ~PF_SPINNING
				player.slide = false
			end
			if player.mo.standingslope
			and not (player.pflags & PF_SPINNING)
				local mo = player.mo
				local slope = mo.standingslope
				local x = cos(slope.xydirection)
				local y = sin(slope.xydirection)
				local angle = slope.xydirection
				if P_GetZAt(slope, mo.x+32*x, mo.y+32*y) > P_GetZAt(slope, mo.x, mo.y)
					angle = slope.xydirection+ANGLE_180
				end
				player.pflags = $1|PF_SPINNING
				P_InstaThrust(player.mo, angle, 5*FU)
			elseif not (player.pflags & PF_SPINNING)
				player.pflags = $1|PF_SPINNING
			end
			P_ButteredSlope(player.mo)
			--player.pflags = $1|PF_SPINNING
			if P_IsObjectOnGround(player.mo)
				P_SpawnSkidDust(player, player.speed/2, 1)
			end
			player.powers[pw_strong] = $1|STR_ATTACK|STR_ANIM
		elseif not player.slide
		and player.mo.state == S_MAR_SLIDE
			player.pflags = $ & ~PF_SPINNING
			if not (player.pflags & PF_JUMPED)
				player.mo.state = S_PLAY_STND
			else
				player.mo.state = S_PLAY_JUMP
			end
		end
	end
end)

addHook("MobjMoveBlocked", function(pmo)
	if pmo.skin ~= "mmario"
	or not pmo.player.slide return end
	
	pmo.player.slide = false
end)