
-- extra stuff
-- like uh throwing fireballs
-- and uh color changing in invincibility

freeslot("S_MAR_FBTHROW") -- fb is fireball

states[S_MAR_FBTHROW] = {
    sprite = SPR_PLAY,
    frame = SPR2_FIRE,
    tics = TICRATE/4,
    nextstate = S_PLAY_STND
}

addHook("PlayerThink", function(p)
	if p.mo.skin ~= "mmario" return end
	
	if (p.powers[pw_shield] & SH_FIREFLOWER)
	and p.weapondelay == 34
	and not G_RingSlingerGametype()
		p.fblaststate = p.mo.state
		p.mo.state = S_MAR_FBTHROW
	end
	
	if p.fblaststate == S_MAR_SPIN
	and not p.spinjum
		p.fblaststate = S_PLAY_STND
	end
	
	if p.fblaststate == S_MAR_PSJUMP
	and p.pspeed.time < 5*TICRATE
		p.fblaststate = S_PLAY_JUMP
	end
	
	if p.fblaststate
	and p.mo.state ~= S_MAR_FBTHROW
		p.mo.state = p.fblaststate
		p.fblaststate = nil
	end
	
	if p.powers[pw_invulnerability] ~= 0
		local invcolors = {
			[1] = SKINCOLOR_RED,
			[2] = SKINCOLOR_BLUE,
			[3] = SKINCOLOR_ROSY,
			[4] = SKINCOLOR_GREEN,
			[5] = SKINCOLOR_YELLOW
		}
		if leveltime%5 == 0
			p.invcolor = $+1
		end
		if p.invcolor > 5
			p.invcolor = 1
		end
		p.mo.colorized = true
		if not p.invcolorised
			p.oldinvcolor = p.mo.color
			p.invcolorised = true
		end
		p.mo.color = invcolors[p.invcolor]
	elseif p.invcolorised
		p.mo.colorized = false
		p.mo.color = p.oldinvcolor
		p.invcolorised = false
		p.oldinvcolor = nil
	end
		
	-- gravity stuff i think
	if not P_IsObjectOnGround(p.mo)
		local grav = P_GetMobjGravity(p.mo)
		if (p.mo.eflags & MFE_VERTICALFLIP)
			grav = -$
		end
		P_SetObjectMomZ(p.mo, -grav/5, true)
	end
end)

--super color ?! - marifan
addHook("PlayerThink", function(player)
	if player.mo.skin == "mmario"
	and player.powers[pw_super]
	player.mo.color = player.skincolor
	end
end)
