
-- hooray p speed
-- that means mario now runs
-- with a button :D

freeslot("S_MAR_PSJUMP", "sfx_pspeed") --PS is P-Speed

states[S_MAR_PSJUMP] = {
    sprite = SPR_PLAY,
    frame = SPR2_TWIN,
    tics = -1,
    nextstate = S_MAR_PSJUMP
}

sfxinfo[sfx_pspeed].caption = "P-Speed"

local function uwSpeed(p, speed) --uw is underwater
	if (p.mo.eflags & MFE_UNDERWATER)
		return speed/3
	else
		return speed
	end
end

addHook("PlayerThink", function(p)
	if p.mo.skin ~= "mmario" return end
	
	if p.speed >= p.runspeed
		if (p.panim == PA_JUMP or p.panim == PA_FALL or p.panim == PA_SPRING)
		or (p.mo.state == S_PLAY_RUN and not P_IsObjectOnGround(p.mo))
			p.mo.state = S_MAR_PSJUMP
		end
	end
	
	if not p.crouch
		local futhingie = p.pspeed.time*FU/(5*TICRATE)
		if not ((p.cmd.buttons & BT_SPIN) or hold ~= 1)
			futhingie = 0
		end
		p.normalspeed = ease.linear(futhingie, skins[p.mo.skin].normalspeed, 38*FU)
		p.runspeed = ease.linear(futhingie, 69420*FU, skins[p.mo.skin].runspeed)
	end
	
	if ((p.cmd.buttons & BT_SPIN) or p.pspeedhold ~= true)
	and p.speed >= uwSpeed(p, skins[p.mo.skin].normalspeed-5*FU)--skins[p.mo.skin].normalspeed-5*FU
	and not p.crouch
	and not P_PlayerInPain(p)
		if p.pspeed.time < 5*TICRATE
			p.pspeed.time = $+2
		else
			if not S_SoundPlaying(p.mo, sfx_pspeed)
			and p.speed >= p.runspeed-5*FU
			and not p.pspeedsilent
				S_StartSound(p.mo, sfx_pspeed, p)
			end
		end
	else
		if not p.spinjump
			if p.pspeed.time > 0
				p.pspeed.time = $-1
			else
				p.pspeed.time = 0
			end
		end
	end
end)