
-- doing the var stuff
-- and also commands

-- shhhhhh this isnt here
COM_AddCommand("paper_mario", function(p, narg)
	if (p and p.valid)
		if p.papermmario
			p.papermmario = false
			if (p.mo.renderflags & RF_PAPERSPRITE)
				p.mo.renderflags = $ & ~RF_PAPERSPRITE
			end
		else
			p.papermmario = true
			if not (p.mo.renderflags & RF_PAPERSPRITE)
				p.mo.renderflags = $1|RF_PAPERSPRITE
			end
		end
	end
end)

COM_AddCommand("mario_pspeedsilent", function(p, narg)
	local thing = ""
	if p.pspeedsilent
		thing = "not"
	end
	local arg = string.lower(tostring(narg))
	if (p and p.valid)
		if arg == "on" or arg == "true" or arg == "1"
			p.pspeedsilent = true
		elseif arg == "off" or arg == "false" or arg == "0"
			p.pspeedsilent = false
		else
			CONS_Printf(p, "Your P-Speed is currently "+thing+" silent. Please use On or Off to change this.")
		end
	else
		CONS_Printf(p, "Please use this in a level.")
	end
end)

COM_AddCommand("mario_pspeedhold", function(p, narg)
	local thing = "don't need"
	if p.pspeedhold
		thing = "need"
	end
	local arg = string.lower(tostring(narg))
	if (p and p.valid)
		if arg == "on" or arg == "true" or arg == "1"
			p.pspeedhold = true
		elseif arg == "off" or arg == "false" or arg == "0"
			p.pspeedhold = false
		else
			CONS_Printf(p, "You currently "+thing+" need to hold Spin to use P-Speed. Please use On or Off to change this.")
		end
	else
		CONS_Printf(p, "Please use this in a level.")
	end
end)

COM_AddCommand("mario_twirlstyle", function(p, narg)
	local arg = string.lower(tostring(narg))
	local twirlnames = {
		[1] = "New Super Mario Bros.",
		[2] = "Super Mario Galaxy",
		[3] = "Both" -- unused text
	}
	if (p and p.valid)
		if arg == "nsmb" or string.find(arg, "new super mario bros") or arg == "1"
			p.twirlstyle = 1
			p.changedtwirl = true
		elseif string.find(arg, "galaxy") or arg == "2"
			p.twirlstyle = 2
			p.changedtwirl = true
		elseif arg == "both" or arg == "3"
			p.twirlstyle = 3
			p.changedtwirl = true
		else
			CONS_Printf(p, "Your twirl is currently the "+twirlnames[p.twirlstyle]+" one, please specify whether you want the NSMB one, the Galaxy one, or both.")
		end
		if arg and p.changedtwirl
			if p.twirlstyle ~= 3
				CONS_Printf(p, "Your twirl style is now the "+twirlnames[p.twirlstyle]+" twirl.")
			else
				--CONS_Printf(p, "Your twirl style is now a hybrid of both twirls")
				CONS_Printf(p, "Your twirl style is now both twirls (NSMB twirl happens if you try to twirl after the Galaxy one).")
			end
			p.changedtwirl = false
		end
	else
		CONS_Printf(p, "Please use this in a level.")
	end
end)

local function initializeVars(p)
	if p.mo.skin ~= "mmario" return end
	
	p.slide = false
	p.slidespeed = 0
	if p.crouch
		p.height = skins[p.mo.skin].height
		p.normalspeed = skins[p.mo.skin].normalspeed
		p.jumpfactor = skins[p.mo.skin].jumpfactor
	end
	p.crouch = false
	p.oldcolor = nil
	p.spinjum = false
	p.markick = false
	p.markickspeed = 0
	p.markicklanded = false
	p.markickground = false
	p.markickflashing = false
	p.marjumpheld = 0
	p.wallslide = false
	p.walljumpheld = 0
	p.walltics = 0
	if p.twirlstyle == nil
		p.twirlstyle = 1
	end
	p.changedtwirl = false
	p.galtwirl = false
	p.groundgaltwirl = false
	p.galangle = 0
	p.galtwirlspins = 0
	p.galfireheld = 0
	p.nsmbtwirl = false
	p.nsmbcooldown = 0
	p.gpc3held = 0
	p.groundpound = false
	p.gpsprung = false
	p.pspeed = {
		time = 0
	}
	if p.pspeedhold == nil
		p.pspeedhold = true
	end
	if p.pspeedsilent == nil
		p.pspeedsilent = false
	end
	if not p.mmariohudactive
		p.mmariohudactive = false
	end
	p.mmariohud = {
		oneup = false,
		oupgained = 0,
		oupease = 0,
		ouptime = TICRATE/2,
		dead = {
			active = false,
			bump = false
		},
		hudlives = p.lives
	}
	p.mmariorpgmus = false
	p.mmariorpg = false
	p.mmariopthud = {
		enabled = false,
		easething = 0,
		shakeease = 0,
		shakeeases = 0
	}
	p.fblaststate = nil
	p.invcolor = 1
	p.invcolorised = false
	p.oldinvcolor = nil
	p.retrothingfunny = false
	if p.papermmario == nil
		p.papermmario = false
	end
	p.peril = false
	if p.paperoverlay ~= nil
		for i = 1, 4 do
			if not (p.paperoverlay.mobjs[i] and p.paperoverlay.mobjs[i].valid) continue end
			P_RemoveMobj(p.paperoverlay.mobjs[i])
		end
	end
	p.paperoverlay = {
		active = false,
		mobjs = {
			[1] = nil,
			[2] = nil,
			[3] = nil,
			[4] = nil
		}
	}
end

addHook("PlayerSpawn", initializeVars)

addHook("PlayerThink", function(p)
	if p.mo.skin ~= "mmario"
	or p.slide ~= nil return end
	
	initializeVars(p)
end)

-- i lov changing the panim
function A_ChangePAnim(mo, v1, v2)
	if mo.type ~= MT_PLAYER error("this isn't a player dumbass") return end
	
	local var = v1
	if v2 and not v1
		var = v2
	end
	
	mo.player.panim = var
end